loadfile("luaScripts/screen_reader_common.inc")();
loadfile("luaScripts/ui_utils.inc")();
loadfile("luaScripts/Fishing_Func.inc")();

CurrentLure = ""; --Don't Edit
gui_log_fish = {}; --Don't Edit, holds log display
CurrentLureIndex=0; -- 1 = First Lure Player Owns in alphabetically order
PlayersLures={}; --Don't Edit, Holds Current Player Lures
CurrentTime=""; --Don't Edit, Holds Time Check Value
TotalLuresUsed = 0;

TotalCasts=2; --Total Casts per lure, if a fish caught. If no fish then it skips.
SkipCommon = true; --Skips to next lure if fish caught is a common.
--AlmostCaughtAttempts = 0; --Adds additional attempts to the current lure if Unusual, Strange fish are seen
LureChangesToUpdateTimer = 2; --Total lures used before time is updated. Zero updates every new lure.

function LureSetup()
	if CurrentLure == "" then
		--Setup Lures.
		
		arrowcheck = false;
		
		srReadScreen();
		
		arrow=srFindImage("fishing/menu_uparrow.png");
		if arrow then
			srClickMouseNoMove(arrow[0]+3,arrow[1]+3);
			lsSleep(500);
			srReadScreen();
		end
		
		
		
		for i = 1, #Lures do

			lsSleep(100);
			
			lure = srFindImage("fishing/" .. Lures[i]);
			if lure then
				table.insert(PlayersLures,i);
			end
			
			if i > 20 and arrowcheck==false then
				arrowcheck=true;
				--Click down arrow if there is one.
				
				arrow=srFindImage("fishing/menu_downarrow.png");
				if not arrow then
					arrow=srFindImage("fishing/menu_uparrow.png");
					if arrow then
						srClickMouseNoMove(arrow[0]+3,arrow[1]+3);
					end
				else
					srClickMouseNoMove(arrow[0]+3,arrow[1]+3);
				end
				srReadScreen();
				lsSleep(1500);
			end
			
		end
		
		arrow=srFindImage("fishing/menu_uparrow.png");
		if arrow then
			srClickMouseNoMove(arrow[0]+3,arrow[1]+3);
			srReadScreen();
		end
		
		
	else
		--Get Current Lure, and advance to the next.
		
		if CurrentLureIndex == table.getn(PlayersLures) then
			--On last lure, rewind!
			CurrentLureIndex=1;
			arrow=srFindImage("fishing/menu_uparrow.png");
			if arrow then
				srClickMouseNoMove(arrow[0]+3,arrow[1]+3);
			end
		elseif CurrentLureIndex==10 then
			--Check down arrow
			arrow=srFindImage("fishing/menu_downarrow.png");
			if arrow then
				srClickMouseNoMove(arrow[0]+3,arrow[1]+3);
			end
			
			--
			CurrentLureIndex = CurrentLureIndex +1;
		else
			CurrentLureIndex = CurrentLureIndex +1;
		end
	
	end
	
	lsSleep(250);
end

function GetLure()
	srReadScreen();
	lure = srFindImage("fishing/" .. Lures[PlayersLures[CurrentLureIndex]]);
	if not lure then
		--Failed to find lure
		error("cant find lure");
	else
		slure = Lures[PlayersLures[CurrentLureIndex]];
		slure = string.sub(slure,string.find(slure,"_")+1,string.len(slure) - 4);
		--statusScreen("Using Lure " .. slure);
		return slure
	end
end

function UseLure()
	-- Uses lure according to CurrentLureIndex, which is used in PlayersLures which contains each lure the player has. 
	
	if CurrentLureIndex > 15 then
		srReadScreen();
		down = srFindImage("fishing/Menu_DownArrow.png");
		if down then
			srClickMouseNoMove(down[0]+3,down[1]+3);
			lsSleep(500);
		end
	elseif CurrentLureIndex > #Lures then
		CurrentLureIndex = 1;
		srReadScreen();
		up = srFindImage("fishing/Menu_UpArrow.png");
		if up then
			srClickMouseNoMove(up[0]+3,up[1]+3);
			lsSleep(500);
		end
	end
	
	--Find Lure/Use
	srReadScreen();
	lsSleep(500);
	lure = srFindImage("fishing/" .. Lures[PlayersLures[CurrentLureIndex]]);
	if not lure then
		--Failed to find lure
		error("cant find lure");
	else
		srClickMouseNoMove(lure[0]+3,lure[1]+3);
		slure = Lures[PlayersLures[CurrentLureIndex]];
		slure = string.sub(slure,string.find(slure,"_")+1,string.len(slure) - 4);
		CurrentLure = slure;
		lsSleep(100);
		srReadScreen();
		--Insect Menu
		for i = 1, #Lure_Types,1 do
			luretype = srFindImage("fishing/" .. Lure_Types[i]);
			if luretype then
				srClickMouseNoMove(luretype[0]+5,luretype[1]+5);
				break;
			end
		end
	end
	
	gui_refresh();
	

end

function ChatReadFish()
	--Find the last line of chat
	lsSleep(100);
	srReadScreen();
	imgs = findAllImages("fishing/chatlog_reddots.png");
	Coords = imgs[#imgs];
	
	
	--Caught Something..  Find Fish Details
	Sfish = "";
				
	for i = 1, #CL_Fish do
	ChatFish = srFindImageInRange("Fishing/" .. CL_Fish[i],Coords[0] ,Coords[1],500,25);
	if ChatFish then
		Sfish = string.sub(CL_Fish[i],string.find(CL_Fish[i],"Fish_") + 5,string.len(CL_Fish[i]) - 4);
		break;
	end
					
	end
				
	if  string.len(Sfish) < 1 then
		error("unknown fish");
	end
				
	--Find Size
	for i = #CL_Number,1,-1 do
		ChatSize =  srFindImageInRange("fishing/" .. CL_Number[i],Coords[0],Coords[1],300,25);
		if ChatSize then
			SNum = string.sub(CL_Number[i],string.find(CL_Number[i],"_") + 1, string.len(CL_Number[i]) - 4);
			break;
		end
	end
				
	return(SNum .. "," .. Sfish);
	
end



function findchat(line)
	--Reads a chat line and returns a basic string for better processing
	
	--Possible fishing messages
	--	No Fish Bit.
	--		(No Fish Bit. You also lost your lure.)
	--	Caught A (SIZE) Deben (FISH)
	--	You almost caught a strange fish
	--	You almost caught an unusual fish
	--	You almost caught an odd fish
	--	Although you lost your lure  (Caught a fish)
	--	Using a (LURE) (TYPE) lure.
	--	You are carrying more than you can manage.
	--	You are carrying too much bulk.
	
	
	--Find the last line of chat
	lsSleep(100);
	srReadScreen();
	imgs = findAllImages("fishing/chatlog_reddots.png");
	Coords = imgs[#imgs];
	
	if line and line > 0 then
		Coords = imgs[(#imgs) - line];
	end
	
	--Find What Happened
	ChatType = "";
	
	for i = 1, #Chat_Types -1,2 do
		test = srFindImageInRange("fishing/" .. Chat_Types[i],Coords[0],Coords[1],500,30);
		
		if test then
			--Found Chat
			ChatType = Chat_Types[i + 1];
			break;
		end
	end
	
	
	--Break down!
	if ChatType then
		--if ChatType == "lure" then
		--elseif ChatType == "nofishlostlure" then
		--elseif ChatType == "nofish" then
		--elseif ChatType == "strange" then
		--elseif ChatType == "unusual" then
		return ChatType;
	else
		error(ChatType);

	end
	
		
	
end



function GetTime()
	--Reads time stamp using special->what time menu
	
	
	--Open Menu
	srKeyEvent(string.char(27));
	lsSleep(500);
	
	--Find Special
	srReadScreen();
	menu = srFindImage("fishing/Menu_Special.png");
	
	if menu then
		srClickMouseNoMove(menu[0]+3,menu[1]+3);
		
		lsSleep(500);
		srReadScreen();
		
		menu = srFindImage("fishing/Menu_WhatTime.png");
		if menu then
			srClickMouseNoMove(menu[0]+3,menu[1]+3);
			lsSleep(500);
		end
	end
	
	
	srReadScreen();
	imgs = findAllImages("fishing/chatlog_reddots.png");
	Coords = imgs[#imgs];
	
	for i = #CL_Time, 1, -1 do
		Stime = srFindImageInRange("fishing/" .. CL_Time[i],Coords[0],Coords[1],400,25);
		if Stime then
			Hour = string.sub(CL_Time[i],string.find(CL_Time[i],"ime_")+4,string.len(CL_Time[i])-4);
			
			AM = srFindImageInRange("fishing/Chatlog_Time_AM.png",Coords[0],Coords[1],400,25);
			if AM then
				CurrentTime=(Hour .. "AM");
				return (Hour .. "AM");
			else
				PM = srFindImageInRange("fishing/chatlog_time_PM.png",Coords[0],Coords[1],400,25);
				if PM then
					CurrentTime=(Hour .. "PM");
					return (Hour .. "PM");
				end
			end
		end
	end
end

function gui_refresh()
	lsDoFrame();
	lsPrintWrapped(10, 5, 0, lsScreenX - 20, 1, 1, 0xFFFFFFff, "Using Lure: " .. CurrentLure);
	lsPrintWrapped(10, 25, 0, lsScreenX - 20, 1, 1, 0xFFFFFFff, "Time: " .. CurrentTime);
	if gui_log_fish then
		
		for i = 1, table.getn(gui_log_fish) do
			lsPrintWrapped(10, 50 + (20*i), 0, lsScreenX - 20, 1, 1, 0xFFFFFFff,gui_log_fish[i]);
		end
		if table.getn(gui_log_fish) > 10 then
			gui_log_fish = {};
		end
	end
end

function doit()
	askForWindow("");
	LureSetup();
	CurrentTime = GetTime();
	lsSleep(1500);
	
	castcount = 0;
	--strangecounter = 0;
	
	while 1 do
		
		checkBreak();
		srReadScreen();
		
		cast = srFindImage("fishing/Button_Fish.png");
		if not cast then
			error("cannot find fishing button");
		end
		
		if castcount == 0 then
			--Update counters
			castcount = 1;
			CurrentLureIndex = CurrentLureIndex +1;
			
			--Update the time if ready, always update before new lure to keep chat proper
			if TotalLuresUsed == LureChangesToUpdateTimer then
				--Update Time
				CurrentTime = GetTime();
				TotalLuresUsed = 0;
			end
			
			--Since no casts been made at all, use a lure
			UseLure();
			lsSleep(1000);
			TotalLuresUsed = TotalLuresUsed + 1;
			
			--update log
			gui_refresh();
			
		elseif castcount  > TotalCasts then
		--	if strangecounter > 0 and strangecounter < AlmostCaughtAttempts then
				--we don't reset yet!
		--	else
				--Reset
				castcount=0;
				strangecounter = 0;
		--	end
		else
			--Cast
			srClickMouseNoMove(cast[0]+3,cast[1]+3);
			while findchat(castcount - 1) == "lure" do
				lsSleep(1000);
				checkBreak();
			end
			castcount = castcount +1;
			
			--Read Chat
			ChatType = findchat();
			if ChatType == "nofishlostlure" then
				--Lost Lure, No fishbit
				castcount=0;
				WriteFishLog("[" .. CurrentLure .. "Lost Lure" .. "\n");
			elseif ChatType == "nofish" then
				--No fishbit
				castcount=0;
			elseif ChatType == "strange" then
				--Strange
				WriteFishLog("[" .. CurrentTime .. "][" .. CurrentLure .. "]" .. "Strange" .. "\n");
				
			--	if AlmostCaughtAttempts > 0 then
			--		strangecounter = strangecounter +1;
			--	end
				
			elseif ChatType == "unusual" then
				WriteFishLog("[" .. CurrentTime .. "][" .. CurrentLure .. "]" .. "Unusual" .. "\n");
				
			--	if AlmostCaughtAttempts > 0 then
			--		strangecounter = strangecounter +1;
			--	end
				
			elseif ChatType == "carry" then
				--chat lines are messed up now
				castcount=0;
				
			elseif ChatType == "caught" or ChatType == "caughtlostlure" then
				Fish = ChatReadFish();
				table.insert(gui_log_fish,Fish);
				if ChatType == "caughtlostlure" then
					WriteFishLog("[" .. CurrentTime .. "][" .. CurrentLure .. "]" .. Fish .. "Lost Lure" .. "\n");
					-- This Needs Check for new lure. This will cause a error if not.
				else
					WriteFishLog("[" .. CurrentTime .. "][" .. CurrentLure .. "]" .. Fish .. "\n");
				end
				
				if SkipCommon == true then
					FishType = string.sub(Fish,string.find(Fish,",") + 1);
					if FishType == "Abdju" or FishType == "Chromis" or FishType == "Catfish" or FishType == "Carp" or FishType == "Perch" or FishType == "Phagrus" or FishType == "Tilapia" then
						--Skip it
						castcount=0;
					end
				end
				
			gui_refresh();
			
			end
		end
	end
end
	